> ## Documentation Index
> Fetch the complete documentation index at: https://developers.telnyx.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Join a conference

> Join an existing call leg to a conference. Issue the Join Conference command with the conference ID in the path and the `call_control_id` of the leg you wish to join to the conference as an attribute. The conference can have up to a certain amount of active participants, as set by the `max_participants` parameter in conference creation request. 

**Expected Webhooks:**

- `conference.participant.joined`
- `conference.participant.left`




## OpenAPI

````yaml https://telnyx-openapi-ng.s3.us-east-1.amazonaws.com/call-control/conferences.yml post /conferences/{id}/actions/join
openapi: 3.1.0
info:
  title: Telnyx Conferences API
  version: 2.0.0
  description: API for Conferences.
  contact:
    email: support@telnyx.com
servers:
  - url: https://api.telnyx.com/v2
security:
  - bearerAuth: []
paths:
  /conferences/{id}/actions/join:
    post:
      tags:
        - Conference Commands
      summary: Join a conference
      description: >
        Join an existing call leg to a conference. Issue the Join Conference
        command with the conference ID in the path and the `call_control_id` of
        the leg you wish to join to the conference as an attribute. The
        conference can have up to a certain amount of active participants, as
        set by the `max_participants` parameter in conference creation request. 


        **Expected Webhooks:**


        - `conference.participant.joined`

        - `conference.participant.left`
      operationId: JoinConference
      parameters:
        - name: id
          description: Uniquely identifies the conference by id or name
          in: path
          required: true
          schema:
            type: string
      requestBody:
        description: Join Conference request object
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/JoinConferenceRequest'
      responses:
        '200':
          $ref: '#/components/responses/ConferenceCommandResponse'
        '401':
          $ref: '#/components/responses/UnauthorizedResponse'
        '422':
          $ref: '#/components/responses/UnprocessableEntityResponse'
      x-codeSamples:
        - lang: JavaScript
          source: |-
            import Telnyx from 'telnyx';

            const client = new Telnyx({
              apiKey: process.env['TELNYX_API_KEY'], // This is the default and can be omitted
            });

            const response = await client.conferences.actions.join('id', {
              call_control_id: 'v3:MdI91X4lWFEs7IgbBEOT9M4AigoY08M0WWZFISt1Yw2axZ_IiE4pqg',
            });

            console.log(response.data);
        - lang: Python
          source: |-
            import os
            from telnyx import Telnyx

            client = Telnyx(
                api_key=os.environ.get("TELNYX_API_KEY"),  # This is the default and can be omitted
            )
            response = client.conferences.actions.join(
                id="id",
                call_control_id="v3:MdI91X4lWFEs7IgbBEOT9M4AigoY08M0WWZFISt1Yw2axZ_IiE4pqg",
            )
            print(response.data)
        - lang: Go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/team-telnyx/telnyx-go\"\n\t\"github.com/team-telnyx/telnyx-go/option\"\n)\n\nfunc main() {\n\tclient := telnyx.NewClient(\n\t\toption.WithAPIKey(\"My API Key\"),\n\t)\n\tresponse, err := client.Conferences.Actions.Join(\n\t\tcontext.TODO(),\n\t\t\"id\",\n\t\ttelnyx.ConferenceActionJoinParams{\n\t\t\tCallControlID: \"v3:MdI91X4lWFEs7IgbBEOT9M4AigoY08M0WWZFISt1Yw2axZ_IiE4pqg\",\n\t\t},\n\t)\n\tif err != nil {\n\t\tpanic(err.Error())\n\t}\n\tfmt.Printf(\"%+v\\n\", response.Data)\n}\n"
        - lang: Java
          source: |-
            package com.telnyx.sdk.example;

            import com.telnyx.sdk.client.TelnyxClient;
            import com.telnyx.sdk.client.okhttp.TelnyxOkHttpClient;
            import com.telnyx.sdk.models.conferences.actions.ActionJoinParams;
            import com.telnyx.sdk.models.conferences.actions.ActionJoinResponse;

            public final class Main {
                private Main() {}

                public static void main(String[] args) {
                    TelnyxClient client = TelnyxOkHttpClient.fromEnv();

                    ActionJoinParams params = ActionJoinParams.builder()
                        .id("id")
                        .callControlId("v3:MdI91X4lWFEs7IgbBEOT9M4AigoY08M0WWZFISt1Yw2axZ_IiE4pqg")
                        .build();
                    ActionJoinResponse response = client.conferences().actions().join(params);
                }
            }
        - lang: Ruby
          source: |-
            require "telnyx"

            telnyx = Telnyx::Client.new(api_key: "My API Key")

            response = telnyx.conferences.actions.join(
              "id",
              call_control_id: "v3:MdI91X4lWFEs7IgbBEOT9M4AigoY08M0WWZFISt1Yw2axZ_IiE4pqg"
            )

            puts(response)
        - lang: PHP
          source: >-
            <?php


            require_once dirname(__DIR__) . '/vendor/autoload.php';


            use Telnyx\Client;

            use Telnyx\Core\Exceptions\APIException;


            $client = new Client(apiKey: getenv('TELNYX_API_KEY') ?: 'My API
            Key');


            try {
              $response = $client->conferences->actions->join(
                'id',
                callControlID: 'v3:MdI91X4lWFEs7IgbBEOT9M4AigoY08M0WWZFISt1Yw2axZ_IiE4pqg',
                beepEnabled: 'always',
                clientState: 'aGF2ZSBhIG5pY2UgZGF5ID1d',
                commandID: '891510ac-f3e4-11e8-af5b-de00688a4901',
                endConferenceOnExit: true,
                hold: true,
                holdAudioURL: 'http://www.example.com/audio.wav',
                holdMediaName: 'my_media_uploaded_to_media_storage_api',
                mute: true,
                region: 'US',
                softEndConferenceOnExit: true,
                startConferenceOnEnter: true,
                supervisorRole: 'whisper',
                whisperCallControlIDs: [
                  'v2:Sg1xxxQ_U3ixxxyXT_VDNI3xxxazZdg6Vxxxs4-GNYxxxVaJPOhFMRQ',
                  'v2:qqpb0mmvd-ovhhBr0BUQQn0fld5jIboaaX3-De0DkqXHzbf8d75xkw',
                ],
              );

              var_dump($response);
            } catch (APIException $e) {
              echo $e->getMessage();
            }
        - lang: CLI
          source: |-
            telnyx conferences:actions join \
              --api-key 'My API Key' \
              --id id \
              --call-control-id v3:MdI91X4lWFEs7IgbBEOT9M4AigoY08M0WWZFISt1Yw2axZ_IiE4pqg
components:
  schemas:
    JoinConferenceRequest:
      required:
        - call_control_id
      type: object
      title: Join Conference Request
      properties:
        call_control_id:
          description: Unique identifier and token for controlling the call
          example: >-
            v2:T02llQxIyaRkhfRKxgAP8nY511EhFLizdvdUKJiSw8d6A9BborherQczRrZvZakpWxBlpw48KyZQ==
          type: string
        client_state:
          description: >-
            Use this field to add state to every subsequent webhook. It must be
            a valid Base-64 encoded string. Please note that the client_state
            will be updated for the participient call leg and the change will
            not affect conferencing webhooks unless the participient is the
            owner of the conference.
          example: aGF2ZSBhIG5pY2UgZGF5ID1d
          type: string
        command_id:
          description: >-
            Use this field to avoid execution of duplicate commands. Telnyx will
            ignore subsequent commands with the same `command_id` as one that
            has already been executed.
          example: 891510ac-f3e4-11e8-af5b-de00688a4901
          type: string
        end_conference_on_exit:
          description: >-
            Whether the conference should end and all remaining participants be
            hung up after the participant leaves the conference. Defaults to
            "false".
          example: true
          type: boolean
        soft_end_conference_on_exit:
          description: >-
            Whether the conference should end after the participant leaves the
            conference. NOTE this doesn't hang up the other participants.
            Defaults to "false".
          example: true
          type: boolean
        hold:
          description: >-
            Whether the participant should be put on hold immediately after
            joining the conference. Defaults to "false".
          example: true
          type: boolean
        hold_audio_url:
          type: string
          example: http://example.com/message.wav
          description: >-
            The URL of a file to be played to the participant when they are put
            on hold after joining the conference. hold_media_name and
            hold_audio_url cannot be used together in one request. Takes effect
            only when "start_conference_on_create" is set to "false". This
            property takes effect only if "hold" is set to "true".
        hold_media_name:
          type: string
          example: my_media_uploaded_to_media_storage_api
          description: >-
            The media_name of a file to be played to the participant when they
            are put on hold after joining the conference. The media_name must
            point to a file previously uploaded to api.telnyx.com/v2/media by
            the same user/organization. The file must either be a WAV or MP3
            file. Takes effect only when "start_conference_on_create" is set to
            "false". This property takes effect only if "hold" is set to "true".
        mute:
          description: >-
            Whether the participant should be muted immediately after joining
            the conference. Defaults to "false".
          example: true
          type: boolean
        start_conference_on_enter:
          description: >-
            Whether the conference should be started after the participant joins
            the conference. Defaults to "false".
          example: true
          type: boolean
        supervisor_role:
          description: >-
            Sets the joining participant as a supervisor for the conference. A
            conference can have multiple supervisors. "barge" means the
            supervisor enters the conference as a normal participant. This is
            the same as "none". "monitor" means the supervisor is muted but can
            hear all participants. "whisper" means that only the specified
            "whisper_call_control_ids" can hear the supervisor. Defaults to
            "none".
          example: whisper
          type: string
          enum:
            - barge
            - monitor
            - none
            - whisper
        whisper_call_control_ids:
          description: >-
            Array of unique call_control_ids the joining supervisor can whisper
            to. If none provided, the supervisor will join the conference as a
            monitoring participant only.
          example:
            - v2:Sg1xxxQ_U3ixxxyXT_VDNI3xxxazZdg6Vxxxs4-GNYxxxVaJPOhFMRQ
            - v2:qqpb0mmvd-ovhhBr0BUQQn0fld5jIboaaX3-De0DkqXHzbf8d75xkw
          type: array
          items:
            type: string
        beep_enabled:
          description: >-
            Whether a beep sound should be played when the participant joins
            and/or leaves the conference. Can be used to override the
            conference-level setting.
          enum:
            - always
            - never
            - on_enter
            - on_exit
          example: on_exit
          type: string
        region:
          $ref: '#/components/schemas/ConferenceRegion'
      example:
        call_control_id: v3:MdI91X4lWFEs7IgbBEOT9M4AigoY08M0WWZFISt1Yw2axZ_IiE4pqg
        client_state: aGF2ZSBhIG5pY2UgZGF5ID1d
        command_id: 891510ac-f3e4-11e8-af5b-de00688a4901
        end_conference_on_exit: true
        hold: true
        hold_audio_url: http://www.example.com/audio.wav
        mute: true
        start_conference_on_enter: true
        supervisor_role: whisper
        whisper_call_control_ids:
          - v2:Sg1xxxQ_U3ixxxyXT_VDNI3xxxazZdg6Vxxxs4-GNYxxxVaJPOhFMRQ
          - v2:qqpb0mmvd-ovhhBr0BUQQn0fld5jIboaaX3-De0DkqXHzbf8d75xkw
        beep_enabled: always
    ConferenceRegion:
      description: >-
        Region where the conference data is located. Defaults to the region
        defined in user's data locality settings (Europe or US).
      example: US
      type: string
      enum:
        - Australia
        - Europe
        - Middle East
        - US
    ConferenceCommandResult:
      type: object
      title: Conference Command Result
      required:
        - result
      properties:
        result:
          type: string
          example: ok
      example:
        result: ok
    call-control_Errors:
      properties:
        errors:
          type: array
          items:
            $ref: '#/components/schemas/call-control_Error'
    call-control_Error:
      required:
        - code
        - title
      properties:
        code:
          type: string
          format: integer
        title:
          type: string
        detail:
          type: string
        source:
          type: object
          properties:
            pointer:
              description: JSON pointer (RFC6901) to the offending entity.
              type: string
              format: json-pointer
            parameter:
              description: Indicates which query parameter caused the error.
              type: string
        meta:
          type: object
  responses:
    ConferenceCommandResponse:
      description: Successful response upon making a conference command.
      content:
        application/json:
          schema:
            type: object
            title: Conference Command Response
            properties:
              data:
                $ref: '#/components/schemas/ConferenceCommandResult'
    UnauthorizedResponse:
      description: >-
        Unauthorized. Authentication failed - the required authentication
        headers were either invalid or not included in the request.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/call-control_Errors'
          example:
            errors:
              - code: '10009'
                title: Authentication failed
                detail: >-
                  The required authentication headers were either invalid or not
                  included in the request.
                meta:
                  url: https://developers.telnyx.com/docs/overview/errors/10009
    UnprocessableEntityResponse:
      description: >-
        Unprocessable entity. The request was well-formed but could not be
        processed due to semantic errors. This includes validation errors,
        invalid parameter values, call state errors, conference errors, queue
        errors, recording/transcription errors, and business logic violations.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/call-control_Errors'
          examples:
            missing_required_parameter:
              summary: Missing required parameter
              value:
                errors:
                  - code: '10004'
                    title: Missing required parameter
                    detail: The 'to' parameter is required and cannot be blank.
                    source:
                      pointer: /to
            invalid_call_control_id:
              summary: Invalid call control ID
              value:
                errors:
                  - code: '90015'
                    title: Invalid Call Control ID
                    detail: The call_control_id provided was not valid.
                    source:
                      pointer: /call_control_id
            call_already_ended:
              summary: Call has already ended
              value:
                errors:
                  - code: '90018'
                    title: Call has already ended
                    detail: This call is no longer active and can't receive commands.
            call_not_answered:
              summary: Call not answered yet
              value:
                errors:
                  - code: '90034'
                    title: Call not answered yet
                    detail: >-
                      This call can't receive this command because it has not
                      been answered yet.
            cannot_record_before_audio_started:
              summary: Cannot record before audio started
              value:
                errors:
                  - code: '90020'
                    title: Call recording triggered before audio started
                    detail: >-
                      Call recording cannot be started until audio has commenced
                      on the call.
            transcription_already_active:
              summary: Transcription already active
              value:
                errors:
                  - code: '90054'
                    title: Call transcription is already in progress
                    detail: Call transcription can not be started more than once.
            ai_assistant_already_active:
              summary: AI Assistant already active
              value:
                errors:
                  - code: '90061'
                    title: AI Assistant is already in progress
                    detail: AI Assistant cannot be started more than once.
            conference_already_ended:
              summary: Conference has already ended
              value:
                errors:
                  - code: '90019'
                    title: Conference has already ended
                    detail: >-
                      This conference is no longer active and can't receive
                      commands.
            conference_name_conflict:
              summary: Conference name conflict
              value:
                errors:
                  - code: '90033'
                    title: Unable to execute command
                    detail: Conference with given name already exists and it's active.
            max_participants_reached:
              summary: Maximum participants reached
              value:
                errors:
                  - code: '90032'
                    title: Maximum number of participants reached
                    detail: >-
                      The maximum allowed value of `max_participants` has been
                      reached at 100.
            queue_full:
              summary: Queue is full
              value:
                errors:
                  - code: '90036'
                    title: Queue full
                    detail: The 'support' queue is full and can't accept more calls.
            call_already_in_queue:
              summary: Call already in queue
              value:
                errors:
                  - code: '90038'
                    title: Call already in queue
                    detail: Call can't be added to a queue it's already in.
            invalid_connection_id:
              summary: Invalid connection ID
              value:
                errors:
                  - code: '10015'
                    title: Invalid value for connection_id (Call Control App ID)
                    detail: >-
                      The requested connection_id (Call Control App ID) is
                      either invalid or does not exist. Only Call Control Apps
                      with valid webhook URL are accepted.
                    source:
                      pointer: /connection_id
            invalid_phone_number_format:
              summary: Invalid phone number format
              value:
                errors:
                  - code: '10016'
                    title: Phone number must be in +E164 format
                    detail: The 'to' parameter must be in E164 format.
                    source:
                      pointer: /to
            srtp_not_supported_for_pstn:
              summary: SRTP not supported for PSTN calls
              value:
                errors:
                  - source:
                      pointer: /media_encryption
                    title: Media encryption not supported for PSTN calls
                    detail: SRTP media encryption is not supported for PSTN calls.
                    code: '10011'
            fork_not_found:
              summary: Call is not forked
              value:
                errors:
                  - code: '90031'
                    title: Call is not currently forked
                    detail: >-
                      Can't stop forking, because the call isn't currently
                      forked.
            media_streaming_used:
              summary: Media streaming in use
              value:
                errors:
                  - code: '90045'
                    title: Media Streaming is used
                    detail: This command can't be issued when media streaming is used.
            invalid_enumerated_value:
              summary: Invalid enumerated value
              value:
                errors:
                  - code: '10032'
                    title: Invalid enumerated value
                    detail: 'The value must be one of: dual, single.'
                    source:
                      pointer: /record_channels
            value_outside_range:
              summary: Value outside of range
              value:
                errors:
                  - code: '10033'
                    title: Value outside of range
                    detail: The value is outside of allowed range 1 to 5000
                    source:
                      pointer: /max_participants
  securitySchemes:
    bearerAuth:
      scheme: bearer
      type: http

````